/*
 * FaintContainer.java
 *
 * Created on February 8, 2003, 1:01 PM
 */

/**
 *
 * @author  Terp Paint
 * @version 2.0
 */
import java.io.*;

/** FaintContainer is used to hold a Faint class object. 
 * It also implements TerpOfficeAppInterface. 
 * There is no visible state for this class. 
 * It works with all operating systems and hardware. 
 * The OS is windows.
 * There is no implementation variances.
 * There is no security constaints.
 * There is no external secification.
 */
public class FaintContainer implements TerpOfficeAppInterface {    
    
    /** This is the Faint object which is used to store a Faint object that is passed from the constructor.
     */    
    Faint newInstance;
    
    /** This is a boolean which is used to store a boolean value which is passed from the constructor.
     */    
    boolean standalone;

    /** Constructor of the FaintContainer. 
     * It creates new FaintContainer object to operate the program.
     * It is called by main function in Faint class to run the progam.
     * The OS is windows.
     * There is no implementation variances.
     * There is no security constaints.
     * There is no external secification.
     * @param alone Boolean value that indicates the program runs.
     */
    public FaintContainer(boolean alone) {
        standalone = alone;
        newInstance = new Faint(standalone);
    }
    
    /** A Faint object created in FaintContainer class calls a dipose function from Faint class. 
     *  This method closes Terp Paint main program.
     * The OS is windows.
     * There is no implementation variances.
     * There is no security constaints.
     * There is no external secification.
     */    
    public void close(){
        newInstance.dispose();
    }
    
    /** This function launches the program and sets a new main canvase image to the newInstance object, 
     * which is from the Faint class. It throws an exception if there is any.
     * The OS is windows.
     * There is no implementation variances.
     * There is no security constaints.
     * There is no external secification.
     * @param file FileInputStream object used to set the new main canvas image.
     */    
    public void launch(File file){         
        if ( file != null ){
            try{
                FileInputStream fis = new FileInputStream(file);
                converter newImage = new converter();
                newInstance.center.setBufferedImage(newImage.FileToBufferedImage(fis));
            }
            catch(Exception fisError){}
        }
        newInstance.show();
    }
    
    /** The Faint object, newInstance created in FaintContainer class, calls the isDisplayable function 
     * from the Faint class. It returns a boolean value, which comes from the isDisplayable function.
     * The OS is windows.
     * There is no implementation variances.
     * There is no security constaints.
     * There is no external secification.
     * @return True boolean value if it is displayable, otherwise false.
     */    
    public boolean alive(){
        return newInstance.isDisplayable();
    }
}
