/*
 * HelpWindow.java
 *
 * Created on April 6, 2003, 1:31 PM
 */

/**
 *
 * @author  mjnguyen
 */


import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.Toolkit.*;
import java.awt.Image.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.colorchooser.*;
import java.io.*;
import java.awt.image.*;
import java.awt.print.*;
import java.awt.datatransfer.Clipboard.*;
import java.awt.datatransfer.*;
import com.sun.image.codec.jpeg.*;
import java.applet.*;
import javax.swing.text.EditorKit;


/** This class is the JFrame that allow navigation through help menus
 */
public class HelpWindow extends JFrame {
    
    /** Creates a new instance of HelpWindow, creates JFrame the same size as Faint program
     * There are no OS/Hardware dependencies and no variances.  There is no need for any security constraints and no references to external specifications.
     * @param faintProgram Faint
     */
    public HelpWindow(JFrame faintProgram) {
        setLocation( (int) faintProgram.getLocation().getX() + 100, (int) faintProgram.getLocation().getY()+100 );
        setTitle( "TerpPaint Help" );
        setSize( new Dimension(500, 400) );
        
        file2 = new File( "windowRegistry.txt");
        System.out.println(file2.getAbsolutePath());
        file = new File( file2.getAbsoluteFile().getParent() );
      
        System.out.println(file.getAbsolutePath());
        
        menuBar = new javax.swing.JMenuBar();
        
        
        terpPaintHelp = new javax.swing.JMenu();
        terpPaintHelp.setText("Contents");
        
        
        
        
        terpPaintOverview = new javax.swing.JMenuItem();
        terpPaintOverview.setText( "Overview" );

        terpPaintOverview.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HelpMenuActionPerformed(evt, "terpPaintOverview.html");
            }
        });   
        
        //action listener.
        
        terpPaintHelp.add( terpPaintOverview );
        
        
        
        
        
        createPictures = new javax.swing.JMenu();
        createPictures.setText("Create Pictures");
        
        // action listener.
        
        drawLine = new javax.swing.JMenuItem();
        drawLine.setText( "To draw a straight line" );

        drawLine.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HelpMenuActionPerformed(evt, "drawLine.htm");
            }
        });   
        
        createPictures.add( drawLine );
    
    
        drawPencil = new javax.swing.JMenuItem();
        drawPencil.setText( "To draw a free-form line" );

        drawPencil.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HelpMenuActionPerformed(evt, "drawPencil.html");
            }
        });   
        
        createPictures.add( drawPencil);
        
    
    
    
       drawCurve = new javax.swing.JMenuItem();
       drawCurve.setText( "To draw a curved line" );

        drawCurve.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HelpMenuActionPerformed(evt, "drawCurve.html");
            }
        });   
        
        createPictures.add( drawCurve );
        
        drawEllipse = new javax.swing.JMenuItem();
        drawEllipse.setText( "To draw an ellipse or circle" );

        drawEllipse.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HelpMenuActionPerformed(evt, "drawEllipse.html");
            }
        });   
        
        createPictures.add( drawEllipse );
        drawRect = new javax.swing.JMenuItem();
        drawRect.setText( "To draw a rectangle or square" );

        drawRect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HelpMenuActionPerformed(evt, "drawRect.html");
            }
        });   
        
        createPictures.add( drawRect );
        drawPoly = new javax.swing.JMenuItem();
        drawPoly.setText( "To draw a polygon" );

        drawPoly.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HelpMenuActionPerformed(evt, "drawPoly.html");
            }
        });   
        
        createPictures.add( drawPoly );
        text = new javax.swing.JMenuItem();
        text.setText( "To type and format text" );

        text.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HelpMenuActionPerformed(evt, "text.html");
            }
        });   
        
        createPictures.add( text );
        
        eraser = new javax.swing.JMenuItem();
        eraser.setText( "To erase a small area" );

        eraser.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HelpMenuActionPerformed(evt, "eraser.html");
            }
        });   
        
        createPictures.add( eraser);
        eraseselect = new javax.swing.JMenuItem();
        eraseselect.setText( "To erase a large area" );

        eraseselect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HelpMenuActionPerformed(evt, "eraseselect.html");
            }
        });   
        
        createPictures.add( eraseselect);
        eraseimage = new javax.swing.JMenuItem();
        eraseimage.setText( "To erase an entire image" );

        eraseimage.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HelpMenuActionPerformed(evt, "eraserimage.html");
            }
        });   
        
        createPictures.add( eraseimage);
        stretchskew = new javax.swing.JMenuItem();
        stretchskew.setText( "To stretch or skew the image" );

         stretchskew.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HelpMenuActionPerformed(evt, "stretchskew.html");
            }
        });   
        
        createPictures.add(  stretchskew);
        imagesize = new javax.swing.JMenuItem();
        imagesize.setText( "To change the size of your picture" );

        imagesize.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HelpMenuActionPerformed(evt, "imagesize.html");
            }
        });   
        
        createPictures.add( imagesize);
        
        
        
        terpPaintHelp.add( createPictures );
        
        
        workWithColor = new javax.swing.JMenu();
        workWithColor.setText("Work with Colors");
        
        
        setColors = new javax.swing.JMenuItem();
        setColors.setText( "To set the default foreground and background colors" );

        setColors.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HelpMenuActionPerformed(evt, "setColors.html");
            }
        });   
        
        workWithColor.add(setColors);
        
        fillArea = new javax.swing.JMenuItem();
        fillArea.setText( "To fill an area or object with color" );

        fillArea.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HelpMenuActionPerformed(evt, "fillArea.html");
            }
        });   
        
        workWithColor.add(fillArea);
        paintBrush = new javax.swing.JMenuItem();
        paintBrush.setText( "To paint with a brush" );

        paintBrush.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HelpMenuActionPerformed(evt, "paintBrush.html");
            }
        });   
        
        workWithColor.add(paintBrush);
        spray = new javax.swing.JMenuItem();
        spray.setText( "To create an airbrush effect" );

        spray.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HelpMenuActionPerformed(evt, "spray.html");
            }
        });   
        
        workWithColor.add(spray);
        customColors = new javax.swing.JMenuItem();
        customColors.setText( "To create custom colors" );

        customColors.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HelpMenuActionPerformed(evt, "customColors.html");
            }
        });   
        
        workWithColor.add(customColors);
        bw = new javax.swing.JMenuItem();
        bw.setText( "To use black and white instead of color" );

        bw.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HelpMenuActionPerformed(evt, "bw.html");
            }
        });   
        
        workWithColor.add(bw);
        copyColor = new javax.swing.JMenuItem();
        copyColor.setText( "To copy color from one area or object to another" );

        copyColor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HelpMenuActionPerformed(evt, "copyColor.html");
            }
        });   
        
        workWithColor.add(copyColor);
    
        
        
        
        
        // action listener
        
        terpPaintHelp.add( workWithColor );
        
        workWithPictures = new javax.swing.JMenu("Work with Pictures");
        // action listener
        
        pastefrom = new javax.swing.JMenuItem();
        pastefrom.setText( "To insert a bitmap into the current picture" );

        pastefrom.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HelpMenuActionPerformed(evt, "pastefrom.html");
            }
        });   
        
        workWithPictures.add(pastefrom);
    
        fliprotate = new javax.swing.JMenuItem();
        fliprotate.setText( "To flip or rotate a picture" );

        fliprotate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HelpMenuActionPerformed(evt, "fliprotate.html");
            }
        });   
        
        workWithPictures.add(fliprotate);
    
        copypaste = new javax.swing.JMenuItem();
        copypaste.setText( "To copy and paste part of a picture" );

        copypaste.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HelpMenuActionPerformed(evt, "copypaste.html");
            }
        });   
        
        workWithPictures.add(copypaste);
    
        select = new javax.swing.JMenuItem();
        select.setText( "To select part of a picture" );

        select.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HelpMenuActionPerformed(evt, "select.html");
            }
        });   
        
        workWithPictures.add(select);
        
        slideshow = new javax.swing.JMenuItem();
        slideshow.setText( "To view a slide show" );

        slideshow.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HelpMenuActionPerformed(evt, "slideshow.html");
            }
        });   
        
        workWithPictures.add(slideshow);
        
        
        
        terpPaintHelp.add( workWithPictures );
        
        
        
            //String filename = file.getAbsolutePath() + file.separator + "help" + file.separator + "welcome.html";
        String filename = new String("file:\\" + file.getAbsolutePath() + file.separator + "help" + file.separator + "welcome.htm") ;        
        
        fileshown = new HTMLDisplay( filename, "TerpPaint Help Welcome");
        try
        {
            
            
            //this.getContentPane().add(fileshown);
            this.getContentPane().add( fileshown.getScrollPane() );
        
        }
        catch( Exception e ){}
        
        
        menuBar.add(terpPaintHelp) ;
        
        setJMenuBar( menuBar ) ;
        
        
        //pack() ;
        
        setVisible( true ) ;

    };
    
    
    /** This function creates the HTMLDisplay for the file selected through the menu selection.
     * There are no OS/Hardware dependencies and no variances.  There is no need for any security constraints and no references to external specifications.
     * @param evt ActionEvent obj
     * @param filen filename of the html to display
     */    
    public void HelpMenuActionPerformed( java.awt.event.ActionEvent evt, String filen )
    {
        
        String filename = new String("file:\\" + file.getAbsolutePath() + file.separator + "help" + file.separator + filen) ;
        //String filename = new String( "file:\\" + System.getProperty("user.dir") + "\\" + "help\\TerpPaintHelpTopics.html");            
        System.out.println(" FILENAME " + filename ) ;
        try
        {
            
           fileshown = new HTMLDisplay( filename, "TerpPaint Help Welcome");
             
            //this.getContentPane().add(fileshown);
            this.setContentPane( fileshown.getScrollPane() );
            
            //pack() ;
            
            setVisible(true);
        
        }
        catch( Exception e ){}
   
       
        
    }
    
    
    /** File that contains the filepath of the html file to be decoded
     */    
    File file;
    /** File that contains the parent path of file to be opened
     */    
    File file2;
    
    /** The menubar for helpwindow
     */    
    JMenuBar menuBar;
    /** JMenu titled TerpPaint Help
     */    
    JMenu terpPaintHelp;
    /** JMenuItem to see the terppaint overview
     */    
    JMenuItem terpPaintOverview;
    /** JMenu titled TerpPaint Help
     */    
    JMenu createPictures;
    /** JMenu titled Work with Color
     */    
    JMenu workWithColor;
    /** JMenu titled Work With Pictures
     */    
    JMenu workWithPictures;

    
    /** JMenuItem to see the line tool help
     */    
    JMenuItem drawLine;
    /** JMenuItem to see the pencil tool help
     */    
    JMenuItem drawPencil;
    /** JMenuItem to see the curve tool help
     */    
    JMenuItem drawCurve;
    /** JMenuItem to see the ellipse tool help
     */    
    JMenuItem drawEllipse;
    /** JMenuItem to see the rect tool help
     */    
    JMenuItem drawRect;
    /** JMenuItem to see the poly tool help
     */    
    JMenuItem drawPoly;
    /** JMenuItem to see the text tool help
     */    
    JMenuItem text;
    /** JMenuItem to see the eraser tool help
     */    
    JMenuItem eraser;
    /** JMenuItem to see the selection tool help
     */    
    JMenuItem eraseselect;
    /** JMenuItem to see the selectall function help
     */    
    JMenuItem eraseimage;
    /** JMenuItem to see the stretch/skew fucntion help
     */    
    JMenuItem stretchskew;
    /** JMenuItem to see the resize help
     */    
    JMenuItem imagesize;
    
    /** JMenuItem to see the colors help
     */    
    JMenuItem setColors;
    /** JMenuItem to see the fill tool help
     */    
    JMenuItem fillArea;
    /** JMenuItem to see the brush tool help
     */    
    JMenuItem paintBrush;
    /** JMenuItem to see the spray tool help
     */    
    JMenuItem spray;
    /** JMenuItem to see the edit colors help
     */    
    JMenuItem customColors;
    /** JMenuItem to see the grayscale help
     */    
    JMenuItem bw;
    /** JMenuItem to see the medicine tool help
     */    
    JMenuItem copyColor;
    
    /** JMenuItem to see the paste help
     */    
    JMenuItem pastefrom;
    /** JMenuItem to see the flip/rotate help
     */    
    JMenuItem fliprotate;
    /** JMenuItem to see the copy/paste help
     */    
    JMenuItem copypaste;
    /** JMenuItem to see the selctall and select tool help
     */    
    JMenuItem select;
    /** JMenuItem to see the slideshow help
     */    
    JMenuItem slideshow;
    
    
    
    
    /** HTMLDisplay of the fileshown
     */    
    HTMLDisplay fileshown;
    
    
    
    
}
