/**
 * main_canvas.java
 * edited on Feb. 10, 2003
 * @author TerpPaint
 * @version 2.0
 */
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.*;
import java.awt.geom.*;


/** The class main_canvas represents a blank rectangular area of the screen onto
 * which the application can draw or from which the application can trap input
 * events from the user.
 *
 * There are no OS/Hardware dependencies and no variances.  There is no need for any
 * security constraints and no references to external specifications.
 *
 * @author TerpSoft
 * @version 1.0
 */
public class main_canvas extends JPanel {    
    /** LinkedList object that contains the last 4 actions done onto the image
     */
    public LinkedList list;
    /** BufferedImage object that represents main image.
     */
    public BufferedImage main_image = null;    
    /** Color object that represents left mouse click event color.
    */
    public Color left_color;
    /** Color object that represents right mouse click event color.
    */
    public Color right_color;
    
    /** Stroke object that represents the current stroke.
     */
    public Stroke current_stroke;
    /** Font object that represents a current font style.
     */
    public Font current_font;
    /** Initializes place zero, place is the spot in the linked list
     */
    public int place = 0;
    //Shape s = new Shape();

    /** Default line false.
     * true when this tool is chosen
     *
     */
    public boolean line = false;
    /** Default curve false.
     * true when this tool is chosen
     */
    public boolean curve = false;
    /** Default rouned_rectangle false.
     * true when this tool is chosen
     */
    public boolean rounded_rectangle = false;
     /** Default square false.
      * true when this tool is chosen
      */
    public boolean square = false;
    /** Default polygon false.
     * true when this tool is chosen
     */
    public boolean polygon = false;
    /** Default elipse false.
     * true when this tool is chosen
     */
    public boolean elipse = false;
    /** Default selectall false.
     * true when this tool is chosen
     */
    public boolean selectall = false;
    /** Default eraser false.
     * true when this tool is chosen
     */
    public boolean eraser = false;    
    /** Default paint false.
     * true when this tool is chosen
     */
    public boolean paint = false;  
    /** Default medicine false.
     * true when this tool is chosen
     */
    public boolean medicine = false;  
    /** Default zoom false.
     * true when this tool is chosen
     */
    public boolean zoom = false;  
    /** Default pencil false.
     * true when this tool is chosen
     */
    public boolean pencil = false;
    /** Default brush false.
     * true when this tool is chosen
     */
    public boolean brush = false;  
    /** Default spray false.
     * true when this tool is chosen
     */
    public boolean spray = false;  
    /** Default letter false.
     * true when this tool is chosen
     */
    public boolean letter = false;          
    /** Default select false.
     * true when this tool is chosen
     */
    public boolean select = false;
    /** Sets zoomFactor default 1.0 */
    static double zoomFactor = 1.0;
    /** Sets oldZoomFactor default 1.0 */
    static double oldZoomFactor = 1.0;
    
    /** Provides scrolling functionality for the image. Scrollars are shown only if they are required.
     */
    public JScrollPane pictureScrollPane = new JScrollPane();
    /** Image that can be scrolled by setting either the horizontal scroll bar or the vertical scroll bar.
     */
    public ScrollablePicture picture;
    /** Shows all image icons on faint. */
    public ImageIcon main_icon = null;    

    
    /** width of the canvas
     */    
    public int widt =1;
    /** height of canvas
     */    
    public int heig =1;
    
    
    
    /** Starts loading the image icons.
     *
     * There are no OS/Hardware dependencies and no variances.  There is no need for any
     * security constraints and no references to external specifications.
     *
     */
    
    public main_canvas() {
        // Start loading the image icon now.
        
        widt = 500;
        heig = 500;


        System.out.println("preferred size" + getPreferredSize().toString() );




        
        pictureScrollPane.setPreferredSize( new Dimension( widt, heig ) );
        list = new LinkedList();
        clear();
        setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
        add(pictureScrollPane);        
    }
        
    
    /** main_canvas constructor that creates a canvas of the size according to params
     * @param wid width param
     * @param hei height param
     */    
    public main_canvas(int wid, int hei) {
        // Start loading the image icon now.
        
        System.out.println("wid " + wid + " height " + hei );        
        
        widt = wid;
        heig = hei;
        
        
        pictureScrollPane.setPreferredSize(new Dimension(wid, hei));
        list = new LinkedList();
        //main_image = new BufferedImage(wid,hei,BufferedImage.TYPE_INT_RGB);
        
        clear();
        //repaint();
        
        System.out.print("afterclear\n");        
        setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
        add(pictureScrollPane);        
    }



    
 
    

    /** Responds to checkbox events.
     *
     * There are no OS/Hardware dependencies and no variances.  There is no need for any
     * security constraints and no references to external specifications.
     *
     * @param e provides the functionalities of ItemEvent
     */
    public void itemStateChanged(ItemEvent e) {            
        picture.setMaxUnitIncrement(1);
    }
    /** Returns true if any changes occur more than once; otherwise false.
     *
     * There are no OS/Hardware dependencies and no variances.  There is no need for any
     * security constraints and no references to external specifications.
     *
     * @return true if any changes occur more than once; otherwise false.
     */
    public boolean madeChanges() {
    	if(list.size() <=1)
    		return false;
    	return true;
    }
    
    /** sets linked list to size 0, so that undo and redo are disabled
     */    
    public void noChanges() {
        list = new LinkedList();
    }
    
    /** Sets the main image with the default size and color.
     *
     * There are no OS/Hardware dependencies and no variances.  There is no need for any
     * security constraints and no references to external specifications.
     *
     */
    public void clear(){
        System.out.println(list.size());
        if(place != 0){
            for(int i = 0; i < place; ++i){
                list.removeFirst();
            }
        }
        place = 0;
        if(list.size() == 4)
            list.remove(3);
        if(main_image != null){
            main_image = new BufferedImage(main_image.getWidth(),main_image.getHeight(),BufferedImage.TYPE_INT_RGB);
    	}
    	else{
            main_image = new BufferedImage(1,1,BufferedImage.TYPE_INT_RGB);
    	}
        
//        if( main_image != null )
//        { 
        Graphics2D g2d = main_image.createGraphics();
        g2d.setColor(Color.white);
        g2d.fillRect(0,0,main_image.getWidth(),main_image.getHeight());
        BufferedImage tempx = main_image.getSubimage(0,0,main_image.getWidth(), main_image.getHeight());
        list.add(tempx);
           //this.repaint();            
        System.out.println(list.size());        
//        }
    }

    /** Sets the characteristics of the rectangle's border or the lines for any other shape.
     *
     * There are no OS/Hardware dependencies and no variances.  There is no need for any
     * security constraints and no references to external specifications.
     *
     * @param in the border size of the line.
     */
    public void setStroke(int in){
        current_stroke = new BasicStroke(in);
    }
    /** Sets a current font style.
     *
     * There are no OS/Hardware dependencies and no variances.  There is no need for any
     * security constraints and no references to external specifications.
     *
     * @param f contains the specified font, style and size.
     */
    public void setFont(Font f){
        current_font = f;
    }
    /** Creates and draw the graphics and adds to the image list.
     *
     * There are no OS/Hardware dependencies and no variances.  There is no need for any
     * security constraints and no references to external specifications.
     *
     * @param s specifies the bounding of the image to display.
     */
    public void drawIt(Shape s){
        if(place != 0){
            for(int i = 0; i < place; ++i){
                list.removeFirst();
            }
        }
        place = 0;
        if(list.size() == 4)
            list.remove(3);
        Graphics2D g2D = this.main_image.createGraphics();
        g2D.draw(s);
        BufferedImage tempx = main_image.getSubimage(0,0,main_image.getWidth(), main_image.getHeight());
        list.add(0,tempx);
        //repaint();
    }
    /** Resizes the image.
     *
     * There are no OS/Hardware dependencies and no variances.  There is no need for any
     * security constraints and no references to external specifications.
     *
     * @param width a new width size of the image.
     * @param height a new height size of the image.
     */
    public void resizeImage(int width, int height){
        if(place != 0){
            for(int i = 0; i < place; ++i){
                list.removeFirst();
            }
        }
        place = 0;
        if(list.size() == 4)
            list.remove(3);
        System.out.println("Resizing image");
        BufferedImage temp = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
        Graphics2D helper = temp.createGraphics();        
        //helper.
        System.out.println("wid "+ width + " heig " + height );
        
        
        helper.setColor(Color.white);
        helper.fillRect(0,0,width, height);
        helper.drawImage(main_image,null,0,0);

        main_image = getCopy(temp);
        list.add(0,temp);
        //repaint();
    }
    
    
    
    /** resizes image
     * @param width new width
     * @param height new height
     */    
    public void sizeImage(int width, int height){
        if(place != 0){
            for(int i = 0; i < place; ++i){
                list.removeFirst();
            }
        }
        place = 0;
        if(list.size() == 4)
            list.remove(3);
        System.out.println("sizing image");
        BufferedImage temp = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
//        Graphics2D helper = temp.createGraphics();        
        //helper.
        System.out.println("wid "+ width + " heig " + height );
        
        
//        helper.setColor(Color.white);
//        helper.fillRect(0,0,width, height);
//        helper.drawImage(temp,null,0,0);
//        helper.drawImage(main_image,null,0,0);

        main_image = getCopy(temp);
//        list.add(0,temp);
       // repaint();
        
        
        
    }
    
    
    
    
    
    
    /** Sets the main image.
     *
     * There are no OS/Hardware dependencies and no variances.  There is no need for any
     * security constraints and no references to external specifications.
     *
     * @param in contains information of buffered image.
     */
    public void setBufferedImage(BufferedImage in) {
        if(place != 0){
            for(int i = 0; i < place; ++i){
                list.removeFirst();
            }
        }
        place = 0;
        if(list.size() == 4)
           list.remove(3);
          main_image = in;
        list.add(0,main_image);
        repaint();
    }
    /** Returns the main image.
     *
     * There are no OS/Hardware dependencies and no variances.  There is no need for any
     * security constraints and no references to external specifications.
     *
     * @return the buffereImage object.
     */
    public BufferedImage getBufferedImage(){
        //repaint();
        return getCopy(main_image);
    }
    /** Returns a copy of main image object.
     *
     * There are no OS/Hardware dependencies and no variances.  There is no need for any
     * security constraints and no references to external specifications.
     *
     * @param in contains information of buffered image.
     * @return the copy of buffereImage object.
     */
    public BufferedImage getCopy(BufferedImage in){
       BufferedImage temp = new BufferedImage(in.getWidth(), in.getHeight(),BufferedImage.TYPE_INT_RGB);
       Graphics2D g2d = temp.createGraphics();
       g2d.drawImage(in,null,0,0);
       return temp;
    }
    /** Sets the left mouse button color.
     *
     * There are no OS/Hardware dependencies and no variances.  There is no need for any
     * security constraints and no references to external specifications.
     *
     * @param in the color to be the left_color.
     */
    public void setLeftColor(Color in){
        left_color = in;
    }
    /** Sets the right mouse button color.
     *
     * There are no OS/Hardware dependencies and no variances.  There is no need for any
     * security constraints and no references to external specifications.
     *
     * @param in the color to be the right_color.
     */
    public void setRightColor(Color in) {
        right_color = in;
    }
    
    //***************************BEGINNING OF PAINT METHOD
    /** Sets the main image scale and draw image if the main image is not null.
     *
     * There are no OS/Hardware dependencies and no variances.  There is no need for any
     * security constraints and no references to external specifications.
     *
     * @param g supports Graphics2D object to provide the functionality of it.
     */
    public void paint(Graphics g) {        
       if (main_image != null)
        {   
            Graphics2D g2d = (Graphics2D)g;
            AffineTransform t = new AffineTransform();
          	t.setToScale(zoomFactor,zoomFactor);
            BufferedImage temp = new BufferedImage((int)(main_image.getWidth()*zoomFactor), 
            									   (int)(main_image.getHeight()*zoomFactor), BufferedImage.TYPE_INT_RGB);
            Graphics2D gd = temp.createGraphics();
            gd.drawImage(main_image,t,null);
                        
            g2d.drawImage((Image)temp,0,0,temp.getWidth(),temp.getHeight(),null);
            main_icon = new ImageIcon((Image)temp);
            
            picture = new ScrollablePicture(main_icon, 1);            
            
            int oldX = (int)pictureScrollPane.getViewport().getViewPosition().getX();
            int oldY = (int)pictureScrollPane.getViewport().getViewPosition().getY();
            Point old = new Point(oldX,oldY);
            pictureScrollPane.setViewportView(picture);
            pictureScrollPane.getViewport().setViewPosition(old);            
            pictureScrollPane.paintAll(g2d);                      
       }        
    }
    //***************************END OF PAINT METHOD
    
    /** Cancels the last drawing action.
     *
     * There are no OS/Hardware dependencies and no variances.  There is no need for any
     * security constraints and no references to external specifications.
     *
     */
    public void undo(){
        System.out.println("UNDO" + list.size() + " " + place);
        if(place+1 <=list.size()-1){
            ++place;
            main_image = (BufferedImage)list.get(place);
        }
        //repaint();
    }
    /** Repeats the last drawing action.
     *
     * There are no OS/Hardware dependencies and no variances.  There is no need for any
     * security constraints and no references to external specifications.
     *
     */
    public void redo(){
        System.out.println("REDO" + list.size() + " " + place);
        if(place >0){
            --place;
            main_image = (BufferedImage)list.get(place);
        }
        //repaint();
    }
    
    /** Returns the coordinate.
     *
     * There are no OS/Hardware dependencies and no variances.  There is no need for any
     * security constraints and no references to external specifications.
     *
     * @param coord the scale of the coordinate.
     * @return the integer coordinate.
     */
    public int canvasScale(int coord) { return coord; }
    
    /** Sets the zoomFactor.
     *
     * There are no OS/Hardware dependencies and no variances.  There is no need for any
     * security constraints and no references to external specifications.
     *
     * @param factor the size of the zoom factor.
     */
    public void setZoom(double factor){
        zoomFactor = factor;
    }
    /** Sets the size of the old zoom factor.
     *
     * There are no OS/Hardware dependencies and no variances.  There is no need for any
     * security constraints and no references to external specifications.
     *
     * @param factor the size of the zoom to be the old zoom factor.
     */
    public void setOldZoom(double factor){
        oldZoomFactor = factor;
    }
    /** Returns the size of the zoom factor.
     *
     * There are no OS/Hardware dependencies and no variances.  There is no need for any
     * security constraints and no references to external specifications.
     *
     * @return the size of the zoom factor.
     */
    public double getZoom(){
        return(zoomFactor);
    }
    /** Returns the size of the old zoom factor.
     *
     * There are no OS/Hardware dependencies and no variances.  There is no need for any
     * security constraints and no references to external specifications.
     *
     * @return the size of the old zoom factor.
     */
    public double getOldZoom(){
        return(oldZoomFactor);
    }    
    
    //beginning of invertColors()
    /** Inverts the colors for drawing with the graphics context.
     *
     * There are no OS/Hardware dependencies and no variances.  There is no need for any
     * security constraints and no references to external specifications.
     */
    public void invertColors(){

        int w = main_image.getWidth();
        int h = main_image.getHeight();
        int x = main_image.getMinX();
        int y = main_image.getMinY();
        
        int[] pixels = new int[w * h];
        PixelGrabber pg = new PixelGrabber((Image)main_image, x, y, w, h, pixels, 0, w);
        try 
        {
            pg.grabPixels();
        } catch (InterruptedException e) 
        {
            System.err.println("interrupted waiting for pixels!");
            return;
        }

        int[] rgbArray = new int[w * h];
        for (int j = 0; j < h; j++) 
        {
            for (int i = 0; i < w; i++) 
            {                
                int pixel = pixels[j * w + i];
                //int alpha = (pixel >> 24) & 0xff;
                int red = (pixel >> 16) & 0xff;
                int green = (pixel >> 8) & 0xff;
                int blue = (pixel ) & 0xff;
                
                red = Math.abs((red - 255));
                green = Math.abs((green - 255));                
                blue = Math.abs((blue - 255));
                Color newColor = new Color(red,green,blue);
                
                main_image.setRGB(x+i,y+j,newColor.getRGB());
            }
        }        
        //repaint();
    }
    //end of invertColors()
        
    /** Creates the main drawing frame.
     *
     * There are no OS/Hardware dependencies and no variances.  There is no need for any
     * security constraints and no references to external specifications.
     *
     * @param s the command line argument.
     */
    public static void main(String s[]) {
        JFrame frame = new JFrame("ScrollDemo");
        frame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
 
        frame.setContentPane(new main_canvas());
        frame.pack();
        frame.setVisible(true);
    }
}
